/// <reference types="ember" />
import ApplicationInstance from '@ember/application/instance';
export interface ComponentManagerArgs {
    named: object;
    positional: any[];
}
interface IHookedComponentWrapper {
    renderFn: Function;
    renderTimer: any;
    uid: number;
    args: {
        [key: string]: any;
    };
    update(): void;
}
interface IHookState {
    callId: number;
    createContext: Function;
    getContext: Function;
    deleteContext: Function;
    setContext: Function;
    incrementCallId: Function;
    resetCallId: Function;
}
export declare function createHookState(hookName: string, defaultValue?: Function | null): IHookState;
export declare function destroyHookState(hookName: string): void;
export declare function getHookState(hookName: string): IHookState;
export declare function addBeforeDestroyTask(cb: Function): void;
export declare function addBeforeCallTask(cb: Function): void;
export declare function customHook(hookFunction: Function): Function;
export declare function useState(value: any): [any, Function];
export declare function getRerender(): any;
export declare function getService(serviceName: string): any;
export declare function getController(controllerName: string): any;
export declare function getRoute(routeName: string): any;
export declare function getContextId(): number;
export declare function useLayoutEffect(cb: Function, cacheKeys?: false | any[]): void;
export declare function useEffect(cb: Function, cacheKeys?: false | any[]): void;
export declare function getOwner(): any;
export default class ReactHooksComponentManager {
    static create(attrs: any): ReactHooksComponentManager;
    capabilities: any;
    constructor(owner: ApplicationInstance);
    createCompnentContext(Klass: Function, args?: any): IHookedComponentWrapper;
    createComponent(Klass: Function, args: ComponentManagerArgs): IHookedComponentWrapper;
    updateComponent(instance: IHookedComponentWrapper, args: ComponentManagerArgs): void;
    destroyComponent(component: IHookedComponentWrapper): void;
    getContext(component: any): any;
    didCreateComponent(component: IHookedComponentWrapper): void;
    didUpdateComponent(component: IHookedComponentWrapper): void;
}
export {};
