/// <reference types="ember" />
import ApplicationInstance from '@ember/application/instance';
export interface ComponentManagerArgs {
    named: object;
    positional: any[];
}
export declare function extract(obj?: {}, fallbackItems?: any): any;
export declare function updateContext(this: any, newProps: any): void;
export declare function getContext(context: any): any;
export declare function getEffects(context: any): any;
export declare function useEffect(fn: Function, trackers?: string | string[], firstRenderControl?: boolean): void;
export default class HooksComponentManager {
    static create(attrs: any): HooksComponentManager;
    capabilities: any;
    constructor(owner: ApplicationInstance);
    createCompnentContext(endUserFunction: Function): HooksComponent;
    createComponent(Klass: typeof HooksComponent, args: ComponentManagerArgs): HooksComponent;
    updateComponent(component: HooksComponent, args: ComponentManagerArgs): void;
    destroyComponent(component: HooksComponent): void;
    getContext(component: HooksComponent): any;
    didCreateComponent(component: HooksComponent): void;
    didUpdateComponent(): void;
}
declare class HooksComponent {
    __isFirstRender: boolean;
    __effectsRunning: boolean;
    __effectsState: object | null;
    __locked: boolean;
    __lockTimer: any;
    renderFn: Function;
    constructor(endUserFunction: Function);
    didInsertElement(): void;
    didUpdate(): void;
    destroy(): void;
    readonly extract: typeof extract;
    readonly useEffect: typeof useEffect;
    readonly updateContext: any;
    _renderFn(attrs: any): any;
}
export {};
